<?php
/******************************************************************************/
//                                                                            //
//                             InstantCMS v1.8                                //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2011                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

function calendar(){

    $inCore     = cmsCore::getInstance();
    $inPage     = cmsPage::getInstance();
    $inDB       = cmsDatabase::getInstance();
    $inUser     = cmsUser::getInstance();
	
	$cfg        = $inCore->loadComponentConfig('calendar');
	//    
	if(!$cfg['component_enabled']) { cmsCore::error404(); }

    global $_LANG;
	$inCore->loadLanguage('components/calendar');
	$back=$inCore->getBackURL();

    //DEFAULT VALUES
	if (!isset($cfg['users_can_add'])) { $cfg['users_can_add'] = 1; }		
	if (!isset($cfg['extract_picture'])) { $cfg['extract_picture'] = 1; }
	if (!isset($cfg['reminder'])) { $cfg['reminder'] = 1; }
    if (!isset($cfg['comments'])) { $cfg['comments'] = 1; }
	if (!isset($cfg['color_cal_header'])) { $cfg['color_cal_header'] = '#CCCCEE'; }
    if (!isset($cfg['color_def_day'])) { $cfg['color_def_day'] = '#BDCCE4'; }

    $inCore->loadModel('calendar');
    $model      = new cms_model_calendar();	
	
	$id         = $inCore->request('id', 'int', 0);
	$userid     = $inCore->request('userid', 'int');
	$do         = $inCore->request('do', 'str', 'view');
	$month         = $inCore->request('month', 'str', '');
	
	$inPage->addHeadCSS('components/calendar/css/calendar.css');
/////////////////////////////// SET CITY AND CATEGORY ///////////////////////////////////////////////////////////////////////////////////////////
if ($do=='city'){ 
	$city = urldecode($inCore->request('city', 'str')); 
    $cat_id = substr($inCore->request('cat_id', 'str','cat_'),4);
	 
	if (!empty($city)){ $_SESSION['calendar_city'] = $city; } else { unset($_SESSION['calendar_city']);}
	if (!empty($cat_id)){$_SESSION['calendar_cat_id'] = $cat_id; } else { unset($_SESSION['calendar_cat_id']);}
    $inCore->redirectBack();
}

/////////////////////////////// VIEW MONTH ///////////////////////////////////////////////////////////////////////////////////////////
if ($do=='view'){
	$inPage->addHeadJS('components/calendar/js/monthbar.js');
	$inPage->addHeadJS('components/calendar/js/cat_tree.js');
	//PAGE HEADING	
	$pagetitle  = $inCore->menuTitle();
	if (!$pagetitle) $pagetitle = $_LANG['CALENDAR']; 	
	if (!$month){ // 
	    $title_month=$_LANG[date('M')].' '.date('Y');
		$pagetitle  = $pagetitle.': '.$title_month;
		$inPage->setTitle($pagetitle);
		$inPage->addPathway($_LANG['VIEW_EVENTS'].': '.$title_month,'/calendar/'.date('Ym'));
		$from_date=date('Y-m').'-01'; //   
	}

    if ($month) { // 
	    $title_month=$_LANG[date('M',strtotime($month.'01'))].' '.date('Y',strtotime($month.'01'));	    
	    $pagetitle  = $pagetitle.': '.$title_month;
		$inPage->setTitle($pagetitle); 
		$inPage->addPathway($_LANG['VIEW_EVENTS'].': '.$title_month,'/calendar/'.date('Ym',strtotime($month.'01')));
	    $from_date=date('Y-m',strtotime($month.'01')).'-01'; // 		
	}
	$to_date=date('Y-m', strtotime($from_date)+(3600*24*32)).'-01'; //  	
    $to_date=date('Y-m-d', strtotime($to_date)-(3600*24)); //  	
	$inPage->printHeading($pagetitle);

    //UPDATE CITY AND CATEGORY FILTER
    if ($inCore->inRequest('city')) {
        $city = urldecode($inCore->request('city', 'str'));
		$cat_id = substr($inCore->request('cat_id', 'str','cat_'),4);
        if (!empty($city)){ $_SESSION['calendar_city'] = $city; } else { unset($_SESSION['calendar_city']); }
		if (!empty($cat_id)){$_SESSION['calendar_cat_id'] = $cat_id; } else { unset($_SESSION['calendar_cat_id']);}
    }
    $items      = array();
    $items_list = $model->getRecords($from_date, $to_date);
	$total=sizeof($items_list);
    $is_items   = (bool)$total;

    //FETCH ITEMS
    if ($is_items){        
        foreach($items_list as $item) {
			if (isset($_SESSION['calendar_city']) && $item['city']!=$_SESSION['calendar_city']) continue;
			if (isset($_SESSION['calendar_cat_id']) && !$model->isInCategory($_SESSION['calendar_cat_id'], $item['cat_id'])) continue;
            $item['enc_city'] = urlencode($item['city']);
            //Check item image
			$item['file']='';
			if($cfg['extract_picture']) {
			   $is_res=preg_match('/^.*?<img.*?src=["\']([^"]+)["\']/mi',$item['content'],$res);		 
			   if ($is_res) {
				  $file = $res[1];
				  $full_file=PATH.$file;
				  if (file_exists($full_file)){
					$path_parts = pathinfo($full_file);
                    $ext_len = strlen($path_parts['extension']);
					$file_small	= substr($full_file,0,strlen($full_file)-$ext_len-1).'_s.'.$path_parts['extension'];
					if (!file_exists($file_small)) {
					    $inCore->includeGraphics();
					    @img_resize($full_file, $file_small, 64, 64);
					}
                    $item['file'] = substr($file_small,strlen(PATH));					
                  } 
			   }			
			}			
		
            //Check user access
            if ($inUser->id){
                $item['moderator'] = ($inCore->userIsAdmin($inUser->id) || $item['user_id'] == $inUser->id);
            } else {
                $item['moderator'] = false;
            }
            $items[] = $item;
        }
    }
	
    //DISPLAY
    $smarty = $inCore->initSmarty('components', 'com_calendar_items.tpl');
        $smarty->assign('is_items', $is_items);
        $smarty->assign('cfg', $cfg);
        $smarty->assign('items', $items);	
        $smarty->assign('monthbar', $model->getMonthbar($from_date));
		$smarty->assign('ccities', $model->calendarCities($_SESSION['calendar_city']));
		$smarty->assign('city_action_url', $_SERVER['REQUEST_URI']);
		$smarty->assign('cat_id', isset($_SESSION['calendar_cat_id']) ? $_SESSION['calendar_cat_id'] : '0');		
		$smarty->assign('category', $model->categoryTitle($_SESSION['calendar_cat_id']));		
        $smarty->assign('is_user', $inUser->id);
		$smarty->assign('is_admin', $inCore->userIsAdmin($inUser->id));
    $smarty->display('com_calendar_items.tpl');
						
}
/////////////////////////////// VIEW ITEM ///////////////////////////////////////////////////////////////////////////////////////////
if($do=='read'){
	$remind_state = $inCore->request('remind_state', 'int', 0);
    if ($remind_state) {
	   if ($remind_state>0) {
		   $remind_date	= $inCore->request('remind_date', 'str', '');
	       $remind_time_hours	= $inCore->request('remind_time_hours', 'str', '00');
	       $remind_time_minutes	= $inCore->request('remind_time_minutes', 'str', '00');
	       $remind_time_seconds	= $inCore->request('remind_time_seconds', 'str', '00');
		   $remind_datetime=substr($remind_date,6,4).'-'.substr($remind_date,3,2).'-'.substr($remind_date,0,2).' '.$remind_time_hours.':'.$remind_time_minutes.':'.$remind_time_seconds;
		   $model->addRemind($id, $inUser->id, $remind_datetime);		   
	   } else {
		   $model->removeRemind($id, $inUser->id);
	   }		   
	}
	
	$item   = $model->getRecord($id);
	//print('item=');
    //var_dump($item);

	if (!$item){ cmsCore::error404(); }
	
	    $inPage->addHeadJS('components/calendar/js/monthbar.js');
		$inPage->addHeadJS('components/calendar/js/jquery/jquery.ui.core.js');
        $inPage->addHeadJS('components/calendar/js/jquery/jquery.ui.datepicker.js');
	    $inPage->addHeadCSS('components/calendar/css/jquery/jquery-ui.datepicker.css');
	    $inPage->addHeadJS('components/calendar/js/jquery/jquery.ui.datepicker-ru1.js');
				
		//PATHWAY ENTRY
		$pagetitle =  $item['title'];
		$inPage->setTitle($pagetitle  . ' - '.$_LANG['CALENDAR']);
		$title_month=$_LANG[date('M',strtotime($item['event_datetime']))].' '.date('Y',strtotime($item['event_datetime']));
		$inPage->addPathway($_LANG['VIEW_EVENTS'].': '.$title_month,'/calendar/'.date('Ym',strtotime($item['event_datetime'])));
		$inPage->addPathway($item['title']);
		$inPage->printHeading($item['title']);
		
        //encode city
        $item['enc_city']   = urlencode($item['city']);
		$item['content'] 	= nl2br($item['content']);

		//Check user access
		if ($inUser->id){
			$moderator = ($inCore->userIsAdmin($inUser->id) || $item['user_id'] == $inUser->id);
		} else {
			$moderator = false;		
		}
		$remind_datetime=$model->getRemindDate($id, $inUser->id);
		$is_remind_active=1;
		if (!$remind_datetime) {
			$remind_datetime=date('Y-m-d', strtotime($item['event_datetime'])-(3600*24));
			$is_remind_active=0;
		}
		
		//DISPLAY
		$smarty = $inCore->initSmarty('components', 'com_calendar_item.tpl');						
			$smarty->assign('moderator', $moderator);
			$smarty->assign('item', $item);
			$smarty->assign('remind_date', (substr($remind_datetime,0,1)=='2' ? date('d.m.Y', strtotime($remind_datetime)) : ''));
		$smarty->assign('remind_time', (substr($remind_datetime,-1)=='1' ? date('His', strtotime($remind_datetime)) : ''));
			$smarty->assign('cfg', $cfg);
			$smarty->assign('user_id', $inUser->id);
			$smarty->assign('monthbar', $model->getMonthbar($item['event_datetime']));
			$smarty->assign('is_remind_active', $is_remind_active);
		$smarty->display('com_calendar_item.tpl');
        
}
/////////////////////////////// NEW ITEM OR EDIT ITEM /////////////////////////////////////////////////////////////////////////////////////////
if (($do=='additem') || ($do=='edititem')){
    if ( !$inUser->id ) { cmsUser::goToLogin();	}
	$is_saved	= $inCore->request('is_saved', 'int', 0);
  if ( !$is_saved ) {
	  
	if ($do=='edititem') {
		$item = $model->getRecord($id);
        $moderator = ($inCore->userIsAdmin($inUser->id) || $item['user_id'] == $inUser->id);
		//Show data only for moderators and owners
	    if (!$moderator){
		     cmsCore::addSessionMessage($_LANG['YOU_HAVENT_ACCESS'], 'error');
		     $inCore->redirect('/calendar/'.date('Ym',strtotime($item['event_datetime'])));  
	    }
    }				
	
	//$inPage->backButton(false);
	$inPage->addHeadJS('components/calendar/js/jquery/jquery.ui.core.js');
	$inPage->addHeadJS('components/calendar/js/jquery/jquery.ui.datepicker.js');
	$inPage->addHeadCSS('components/calendar/css/jquery/jquery-ui.datepicker.css');
	$inPage->addHeadJS('components/calendar/js/jquery/jquery.ui.datepicker-ru1.js');
	$inPage->addHeadJS('components/calendar/js/cat_tree.js');
	
	if ($do=='additem') {
	    $inPage->setTitle($_LANG['ADD_EVENT']. ' - '.$_LANG['CALENDAR']);
		$inPage->addPathway($_LANG['CALENDAR'],'/calendar/'.date('Ym'));
		$inPage->addPathway($_LANG['ADD_EVENT']);
        $inPage->printHeading($_LANG['ADD_EVENT_CAL']);
	} else {
	    $inPage->setTitle($item['title']. ' - '.$_LANG['CALENDAR']);
		$inPage->addPathway($_LANG['VIEW_EVENTS'].': '.$_LANG[date('M',strtotime($item['event_datetime']))].' '.date('Y',strtotime($item['event_datetime'])),'/calendar/'.date('Ym',strtotime($item['event_datetime'])));
        $inPage->addPathway($item['title']);
        $inPage->printHeading($_LANG['EDIT_EVENT']);
	}

		$ses_item = cmsUser::sessionGet('item');
		if ($ses_item) { 
		    cmsUser::sessionDel('item'); 
		    $item=$ses_item;
		}

		$item['city'] = $item['city'] ? $item['city'] : $inDB->get_field('cms_user_profiles', 'id='.$inUser->id, 'city');
        $smarty = $inCore->initSmarty('components', 'com_calendar_edit.tpl');
        ($do=='additem') ? $smarty->assign('action', "/calendar/add.html") : $smarty->assign('action', "/calendar/edit{$id}.html");
        $smarty->assign('form_do', $do);
        $smarty->assign('cfg', $cfg);
		$smarty->assign('item', $item);
		$smarty->assign('event_date', (substr($item['event_datetime'],0,1)=='2' ? date('d.m.Y', strtotime($item['event_datetime'])) : ''));
		$smarty->assign('event_time', (substr($item['event_datetime'],-1)=='1' ? date('His', strtotime($item['event_datetime'])) : ''));
		$is_dur_days=strtotime($item[duration])>0;
		$smarty->assign('duration', (substr($item['duration'],-1)=='1' ? ($is_dur_days ? '':'00').date($is_dur_days ? 'dHis':'His', strtotime($item[duration])) : ''));
		$smarty->assign('cities', $model->calendarCities('', '-- '.$_LANG['NOT_SELECT'].' --'));
		$smarty->assign('category', $model->categoryTitle($item['cat_id']));
        $smarty->assign('is_admin', $inUser->is_admin);
        $smarty->display('com_calendar_edit.tpl');
        return;
    }

    if ( $is_saved ) {
        
        //  
        $title	= $inCore->request('title', 'str', '');
		$event_date	= $inCore->request('event_date', 'str', '');
		$event_time_hours	= $inCore->request('event_time_hours', 'str', '00');
		$event_time_minutes	= $inCore->request('event_time_minutes', 'str', '00');
		$event_time_seconds	= $inCore->request('event_time_seconds', 'str', '00');
		$event_dur_days	= $inCore->request('event_dur_days', 'str', '00');
		$event_dur_hours	= $inCore->request('event_dur_hours', 'str', '00');
		$event_dur_minutes	= $inCore->request('event_dur_minutes', 'str', '00');
		$event_dur_seconds	= $inCore->request('event_dur_seconds', 'str', '00');		
		$city_ed    = $inCore->request('city_ed', 'str', '');
        $city       = $inCore->request('city', 'str', '');
        $city       = $city_ed ? $city_ed : $city;
		$cat_id     = intval(substr($inCore->request('cat_id', 'str', 'cat_'),4));
		$place 	= $inCore->request('place', 'str', '');		
        $content 	= $inCore->request('content', 'html', '');
        $captcha    = $inCore->request('code', 'str', '');
		       
		$errors = false;
        if (!$title) 	 { cmsCore::addSessionMessage($_LANG['NEED_TITLE'], 'error'); $errors = true; }
        if (!$event_date) { cmsCore::addSessionMessage($_LANG['NEED_DATE'], 'error'); $errors = true; }

        if (!$inCore->checkCaptchaCode($captcha) && !$inUser->is_admin)	{ 
		      cmsCore::addSessionMessage($_LANG['ERR_CAPTCHA'], 'error'); 
		      $errors = true; 
		}

        $item['title']    = $title;
		$item['event_datetime']=substr($event_date,6,4).'-'.substr($event_date,3,2).'-'.substr($event_date,0,2).' '.$event_time_hours.':'.$event_time_minutes.':'.$event_time_seconds;
		$item['duration']    = '1970-01-'.$event_dur_days.' '.$event_dur_hours.':'.$event_dur_minutes.':'.$event_dur_seconds;
		$item['city']    = $city;
		$item['cat_id']    = $cat_id;			
		$item['place']    = $place;
		$item['content']=$content;
		if (!$item['user_id']) $item['user_id']=$inUser->id;		
		if ($errors) {		
			cmsUser::sessionPut('item', $item);
			($do=='additem')? $inCore->redirect('/calendar/add.html') : $inCore->redirect('/calendar/edit{$item.id}.html');			
        }		
        if ($do=='additem') {
			$item_id = $model->addRecord($item);
			// 
		    cmsActions::log('add_calendar', array(
					'object' => ' ',
					'object_url' => '/calendar/read'.$item_id.'.html',
					'object_id' => $item_id,
					'target' => $_LANG[date('M',strtotime($item['event_datetime']))].' '.date('Y',strtotime($item['event_datetime'])),
					'target_url' => '/calendar/'.date('Ym',strtotime($item['event_datetime'])),
					'target_id' => 0, 
					'description' => ''.$event_date.' '.$event_time_hours.':'.$event_time_minutes.' '.$item['title']
		    ));
		} else {
			//print('item update=');
			//var_dump($item);
			//die('here');
			$model->updateRecord($id, $item);
		}
		$inCore->redirect('/calendar/'.date('Ym',strtotime($item['event_datetime'])));
    }
	
}

/////////////////////////////// DELETE BOARD ITEM /////////////////////////////////////////////////////////////////////////////////////////
if ($do == 'delete'){
	//Check user access
	$item = $model->getRecord($id);
    if (!$item){ cmsCore::error404(); }

	if ($inUser->id){
        $moderator = ($inCore->userIsAdmin($inUser->id) || $item['user_id'] == $inUser->id);
    } else {
        $moderator = false;
    }

	if (!$moderator){
		cmsCore::addSessionMessage($_LANG['YOU_HAVENT_ACCESS'], 'error');
		$inCore->redirect('/calendar/'.date('Ym',strtotime($item['event_datetime'])));
	}

        if (!$inCore->inRequest('godelete')){
			//confirmation
            $inPage->setTitle($_LANG['DELETE_EVENT']. ' - '.$_LANG['CALENDAR']);
            $inPage->addPathway($_LANG['VIEW_EVENTS'].': '.date('F - Y',strtotime($item['event_datetime'])),'/calendar/'.date('Ym',strtotime($item['event_datetime'])));
            $inPage->addPathway($_LANG['DELETING_EVENT'].' '.$item['title']);

            $confirm['title']               = $_LANG['DELETING_EVENT'];
            $confirm['text']                = $_LANG['YOU_SURE_DELETE_EVENT'].' "'.$item['title'].'"?';
            $confirm['action']              = $_SERVER['REQUEST_URI'];
            $confirm['yes_button']['name']  = 'godelete';

            $smarty = $inCore->initSmarty('components', 'action_confirm.tpl');
            $smarty->assign('confirm', $confirm);
            $smarty->display('action_confirm.tpl');
		}

        if ($inCore->inRequest('godelete')){
			//deleting
            $model->deleteRecord($id);
			cmsCore::addSessionMessage($_LANG['EVENT_IS_DELETED'], 'info');
            $inCore->redirect('/calendar/'.date('Ym',strtotime($item['event_datetime'])));
		}

}
/////////////////////////////// /////////////////////////////// /////////////////////////////// /////////////////////////////// //////
} //function
?>