<?php
/******************************************************************************/
//                                                                            //
//                             InstantCMS v1.8                                //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2011                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

class cms_model_calendar{

	function __construct(){
        $this->inDB = cmsDatabase::getInstance();
		$this->inCore = cmsCore::getInstance(); 
		$this->inCore->loadLanguage('components/calendar');
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function install(){
		        
       return true;

    }

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function getCommentTarget($target, $target_id) {

        $result = array();

        switch($target){

            case 'calendar': $item               = $this->inDB->get_fields('cms_cal_events',                               "id={$target_id}", 'title');
                              if (!$item) { return false; }
                              $result['link']     = '/calendar/read'.$target_id.'.html';
                              $result['title']    = $item['title'];
                              break;

        }
        return ($result ? $result : false);
    }
/* ==================================================================================================== */
/* ==================================================================================================== */ 

public function getMonthbar($some_date){ //  

    global $_LANG;

    $html  = '<div class="monthbar">';
    $html .= '<span class="monthbar_title">'.$_LANG['MONTHES'].'&nbsp;&rarr;</span>';
	$first_day_date=date('Y-m-d', strtotime($some_date));
	//    
	
	if (substr($first_day_date,-2)!='01') $first_day_date=date('Y-m', strtotime($first_day_date)).'-01';
    //  
    $prev1_month=date('Y-m', strtotime($first_day_date)-(3600*24*2)).'-01';
	$prev2_month=date('Y-m', strtotime($prev1_month)-(3600*24*2)).'-01';
	$next1_month=date('Y-m', strtotime($first_day_date)+(3600*24*32)).'-01';
	$next2_month=date('Y-m', strtotime($next1_month)+(3600*24*32)).'-01';	
	
    
    $html .= '<a href="javascript:goPrevMonth()" class="monthbar_ref" style="text-align: right">&nbsp;&nbsp;&lt;&lt;&nbsp;&nbsp;</a>';
	$html .= '<span id="monthbar_span"><a href="/calendar/'.date('Ym',strtotime($prev2_month)).'" class="monthbar_item">'.$_LANG[date('M',strtotime($prev2_month))].date('Y',strtotime($prev2_month)).'</a>';
	$html .= ' <a href="/calendar/'.date('Ym',strtotime($prev1_month)).'" class="monthbar_item">'.$_LANG[date('M',strtotime($prev1_month))].date('Y',strtotime($prev1_month)).'</a> ';
    $html .= ' <a href="/calendar/'.date('Ym',strtotime($first_day_date)).'" class="monthbar_current">'.$_LANG[date('M',strtotime($first_day_date))].date('Y',strtotime($first_day_date)).'</a> ';
	$html .= ' <a href="/calendar/'.date('Ym',strtotime($next1_month)).'" class="monthbar_item">'.$_LANG[date('M',strtotime($next1_month))].date('Y',strtotime($next1_month)).'</a> ';
	$html .= ' <a href="/calendar/'.date('Ym',strtotime($next2_month)).'" class="monthbar_item">'.$_LANG[date('M',strtotime($next2_month))].date('Y',strtotime($next2_month)).'</a> </span>';
    $html .= '<a href="javascript:goNextMonth()" class="monthbar_ref" style="text-align: left">&nbsp;&nbsp;&gt;&gt;</a>';       
    $html.='</div>';

    return $html;
}

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function formatDuration($which, $some_datetime) { //    ,    
        global $_LANG;
		$some_datetime=strtotime($some_datetime);
	    if ($which==1) { //	
			return date('d.m.Y', $some_datetime).', '.$_LANG[date('D', $some_datetime)];
		} else if ($which==2) { // 
		    if (date('H:i', $some_datetime)=='00:01') { 
			    return '';
			} else {
			    return $_LANG['Begin'].date('H:i', $some_datetime);
			}
		} else { //
		    $dur=getdate($some_datetime);
			$dur_days=$dur['mday'];
			if ($some_datetime<0) $dur_days=0;
			$dur_hours=$dur['hours'];
			$dur_minutes=$dur['minutes'];
			if (!$dur_days && !$dur_hours && !$dur_minutes) return '';
			$dur_str=$_LANG['Duration'];
			$dur_days_str='';
			$dur_hours_str='';
			$dur_minutes_str='';
			if ($dur_days>0) {			   
			   $dur_days_str=''.$dur_days;
			   if (($dur_days>=11 && $dur_days<=19) || ($dur_days%10 == 0) || (($dur_days%10 >=5) && ($dur_days%10 <=9))) { 
			       $dur_days_str.=$_LANG['Dur_days3'];			
			   } else if ($dur_days%10 == 1) {
				   $dur_days_str.=$_LANG['Dur_days1'];				   
			   } else {
				   $dur_days_str.=$_LANG['Dur_days2'];
			   }
			   $dur_str.= $dur_days_str;				
			}
			if ($dur_hours>0) {			   
			   $dur_hours_str=''.$dur_hours;
			   if (($dur_hours>=11 && $dur_hours<=19) || ($dur_hours%10 == 0) || (($dur_hours%10 >=5) && ($dur_hours%10 <=9))) { 
			       $dur_hours_str.=$_LANG['Dur_hours3'];			
			   } else if ($dur_hours%10 == 1) {
				   $dur_hours_str.=$_LANG['Dur_hours1'];				   
			   } else {
				   $dur_hours_str.=$_LANG['Dur_hours2'];
			   }
			   if ($dur_days>0) $dur_str.=' ';
			   $dur_str.= $dur_hours_str;				
			}			
			if ($dur_minutes>0) {			   
			   $dur_minutes_str=''.$dur_minutes;
			   if (($dur_minutes>=11 && $dur_minutes<=19) || ($dur_minutes%10 == 0) || (($dur_minutes%10 >=5) && ($dur_minutes%10 <=9))) { 
			       $dur_minutes_str.=$_LANG['Dur_minutes3'];			
			   } else if ($dur_minutes%10 == 1) {
				   $dur_minutes_str.=$_LANG['Dur_minutes1'];				   
			   } else {
				   $dur_minutes_str.=$_LANG['Dur_minutes2'];
			   }
			   if (($dur_days>0) || ($dur_minutes>0)) $dur_str.=' ';
			   $dur_str.= $dur_minutes_str;			
			}			
			return $dur_str;	
		}
	}
/* ==================================================================================================== */
/* ==================================================================================================== */

    public function getRecords($from_date=NULL, $to_date=NULL, $is_city_filter=true) { //    
        
		if (is_null($from_date)) $from_date=date('Y-m').'-01'; //  
		if (is_null($to_date)) {
			$to_date=date('Y-m', strtotime($from_date)+(3600*24*32)).'-01'; //  	
		    $to_date=date('Y-m-d', strtotime($to_date)-(3600*24)); //  
		}
		$records = array();		

        $city_filter='';
        if ($is_city_filter) $city_filter = isset($_SESSION['calendar_city']) ? "AND ce.city = '".$_SESSION['calendar_city'].        "'" : '';

        $sql = "SELECT ce.*, ce.event_datetime-NOW() as future_event, ce.event_datetime +substring(ce.duration+0,7)-NOW() as going_event, u.nickname as user, u.login as user_login
                FROM cms_cal_events ce
				LEFT JOIN cms_users u ON u.id = ce.user_id
                WHERE ce.event_datetime >='{$from_date}' AND ce.event_datetime <='{$to_date} 23:59:59' $city_filter ORDER BY ce.event_datetime";

		$result = $this->inDB->query($sql);
        if (!$this->inDB->num_rows($result)){ return false; }	
		
        while($item = $this->inDB->fetch_assoc($result)){
            $item['content']    = nl2br($item['content']);
			$item['event_date_str']   = $this->formatDuration(1, $item['event_datetime']);
			$item['event_time_str']   = $this->formatDuration(2, $item['event_datetime']);
			$item['duration_str']   = $this->formatDuration(3, $item['duration']);
			
			if ($item['future_event']>0) {
				$item['pass_state']=1; // 
			} elseif (($item['future_event']<0) && ($item['going_event']<0)) {
				$item['pass_state']=-1; //  
			} else {
			    $item['pass_state']=0; //   
			}
            $records[$item['id']] = $item;
        }

        //$records = cmsCore::callEvent('GET_CAL_RECORDS', $records);
        return $records;

    }


/* ==================================================================================================== */
/* ==================================================================================================== */ 

    public function getRecord($cal_event_id) { 

               $sql = "SELECT ce.*,ce.event_datetime-NOW() as future_event, ce.event_datetime +substring(ce.duration+0,7)-NOW() as going_event, u.nickname as user, u.login as user_login
                FROM cms_cal_events ce
				LEFT JOIN cms_users u ON u.id = ce.user_id
                WHERE ce.id = $cal_event_id";

        $result = $this->inDB->query($sql);

        if (!$this->inDB->num_rows($result)){ return false; }

        $item = $this->inDB->fetch_assoc($result);

		$item['content']    = nl2br($item['content']);		
		$item['event_date']   = $this->formatDuration(1, $item['event_datetime']);
		$item['event_time']   = $this->formatDuration(2, $item['event_datetime']);
		$item['duration_str']   = $this->formatDuration(3, $item['duration']);
		if ($item['future_event']>0) {
				$item['pass_state']=1; // 
		} elseif (($item['future_event']<0) && ($item['going_event']<0)) {
				$item['pass_state']=-1; //  
		} else {
			    $item['pass_state']=0; //   
		}
        //$record = cmsCore::callEvent('GET_CAL_RECORD', $record);

        return $item;
    }
	
/* ==================================================================================================== */
/* ==================================================================================================== */ 

    public function getComingEvent() { //  ,   

               $sql = "SELECT * FROM cms_cal_events
                   WHERE to_days(event_datetime) >to_days(NOW())
				   ORDER BY event_datetime asc limit 1";

        $result = $this->inDB->query($sql);

        if (!$this->inDB->num_rows($result)){ return false; }

        $item = $this->inDB->fetch_assoc($result);

		$item['content']    = nl2br($item['content']);		
		$item['event_date_str']   = $this->formatDuration(1, $item['event_datetime']);
		$item['event_time_str']   = $this->formatDuration(2, $item['event_datetime']);
		$item['duration_str']   = $this->formatDuration(3, $item['duration']);
		$item['pass_state']=1;

        return $item;
    }	

/* ==================================================================================================== */
/* ==================================================================================================== */ 

    public function getGoingEvents() { //  ,   

               $sql = "SELECT * FROM cms_cal_events
                   WHERE to_days(NOW())-to_days(event_datetime)>0 AND event_datetime+substring(duration+0,7)-NOW()>0	   
				   ORDER BY event_datetime asc";

        $result = $this->inDB->query($sql);

        if (!$this->inDB->num_rows($result)){ return false; }
        $records = array();	
		
        while($item = $this->inDB->fetch_assoc($result)){
            $item['content']    = nl2br($item['content']);
			$item['event_date_str']   = $this->formatDuration(1, $item['event_datetime']);
		    $item['event_time_str']   = $this->formatDuration(2, $item['event_datetime']);
		    $item['duration_str']   = $this->formatDuration(3, $item['duration']);
		    $item['pass_state']=0;		
            $records[$item['id']] = $item;
        }
        return $records;
    }	
	
/* ==================================================================================================== */
/* ==================================================================================================== */

    public function addRecord($item){ // 

        $item = cmsCore::callEvent('ADD_CAL_RECORD', $item);

        $sql = "INSERT INTO cms_cal_events (event_datetime, duration, title,   
           user_id, city, cat_id, place, content) 
           VALUES ('{$item['event_datetime']}', '{$item['duration']}', '{$item['title']}', {$item['user_id']}, '{$item['city']}',{$item['cat_id']},'{$item['place']}', '{$item['content']}')";

        $this->inDB->query($sql);
		
		$item_id = $this->inDB->get_last_id('cms_cal_events');
        return $item_id ? $item_id : false;
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function updateRecord($cal_event_id, $item) {
        $item = cmsCore::callEvent('UPDATE_CAL_RECORD', $item);

        $sql = "UPDATE cms_cal_events
                SET event_datetime='{$item['event_datetime']}', 
					duration='{$item['duration']}',            
					title='{$item['title']}', 
					city='{$item['city']}', 
					cat_id='{$item['cat_id']}',          
					place='{$item['place']}', 
					content='{$item['content']}'
                WHERE id = $cal_event_id";
        $this->inDB->query($sql);
        return true;
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function deleteRecord($cal_event_id) {

		$inCore = cmsCore::getInstance();

        cmsCore::callEvent('DELETE_CAL_RECORD', $cal_event_id);

        $item = $this->getRecord($cal_event_id);
        $sql = "DELETE FROM cms_cal_events WHERE id = $cal_event_id";
        $this->inDB->query($sql);

		$inCore->deleteComments('calendar', $cal_event_id);

		cmsActions::removeObjectLog('add_calendar', $cal_event_id);
        return true;
    }

/* ==================================================================================================== */
/* ==================================================================================================== */
    public function getRemindDate($event_id, $user_id){
		
        $item= $this->inDB->get_fields('cms_cal_events_remind',                               "event_id={$event_id} and user_id={$user_id}", 'remind_datetime','event_id asc');
		return $item ? $item['remind_datetime'] : false;
    }	
/* ==================================================================================================== */

    public function addRemind($event_id, $user_id, $remind_datetime){ // 

        $item= $this->inDB->get_fields('cms_cal_events_remind',                               "event_id={$event_id} and user_id={$user_id}", 'remind_datetime','event_id asc');
        if (!$item) {
		   $sql = "INSERT INTO cms_cal_events_remind (event_id, user_id, remind_datetime) 
               VALUES ({$event_id}, {$user_id}, '{$remind_datetime}')";
		   $this->inDB->query($sql);		
		   $item_id = $this->inDB->get_last_id('cms_cal_events_remind');
           return $item_id ? $item_id : false;
		} else {
		   $sql = "UPDATE cms_cal_events_remind
                SET remind_datetime='{$remind_datetime}'
                WHERE event_id={$event_id} and user_id={$user_id}";
           $this->inDB->query($sql);
		   return true;		
		}
    }
/* ==================================================================================================== */

    public function removeRemind($event_id, $user_id){
		   $sql = "DELETE FROM cms_cal_events_remind
                WHERE event_id={$event_id} and user_id={$user_id}";
           $this->inDB->query($sql);
		   return true;		   
    }

/* ==================================================================================================== */

    public function reminder() { //   
        
        $inConf = cmsConfig::getInstance();
		$now=date('Y-m-d H:i:s');
        $sql = "SELECT cer.event_id, ce.*, u.email as email,u.nickname as user
                FROM cms_cal_events_remind cer
				LEFT JOIN cms_users u ON u.id = cer.user_id
				LEFT JOIN cms_cal_events ce ON ce.id = cer.event_id
                WHERE cer.remind_datetime <='{$now}'";

		$result = $this->inDB->query($sql);
        if (!$this->inDB->num_rows($result)){ return false; }	
        $letter_path    = $_SERVER['DOCUMENT_ROOT'].'/includes/letters/new_cal_event.txt';
        $letter         = file_get_contents($letter_path);
		
        while($item = $this->inDB->fetch_assoc($result)){
			 if (!$item['email']) { continue;}
			    $target_link = '/calendar/read'.$item['event_id'].'.html';
				$event_date=$this->formatDuration(1, ''.$item['event_datetime']).''.$this->formatDuration(2, ''.$item['event_datetime']);								
                $user_letter = $letter;
                $user_letter = str_replace('{sitename}', $inConf->sitename, $user_letter);
                $user_letter = str_replace('{event_link}', 'http://'.$_SERVER['HTTP_HOST'].$target_link, $user_letter);
                $user_letter = str_replace('{event_title}', $item['title'], $user_letter);
                $user_letter = str_replace('{event_date}', $event_date, $user_letter);
                $this->inCore->mailText($item['email'], '  ! - '.$inConf->sitename, $user_letter);
                unset($user_letter);         
        }
		$sql = "DELETE FROM cms_cal_events_remind
                WHERE remind_datetime <='{$now}'";
        $this->inDB->query($sql);
		
        return;     

    }
/* ==================================================================================================== */
/* ==================================================================================================== */
    public function calendarCities($selected='', $none_label = ' '){ //  
        $sql = "SELECT city FROM cms_cal_events GROUP BY city ORDER BY city";
        $result = $this->inDB->query($sql) ;
        $html = '<select id="city" name="city">';
        $html .= '<option value="">'.$none_label.'</option>';
        while($c = $this->inDB->fetch_assoc($result)){
			if (!$c['city']) continue;
            if (strtolower($selected)==strtolower($c['city'])){
                $s = 'selected';
            } else {
                $s = '';
            }
            $pretty = ucfirst(strtolower($c['city']));
            $html .= '<option value="'.$pretty.'" '.$s.'>'.$pretty.'</option>';
        }
        $html .= '</select>';
        return $html;
    }
/* ==================================================================================================== */
/* ==================================================================================================== */
    public function getCategories($parent_id=0){ // 
        $sql = "SELECT * FROM cms_cal_cats WHERE parent_id=".$parent_id." ORDER BY title";
        $result = $this->inDB->query($sql) ;
		$output_str='{';
		$is_first=1;
		while($item = $this->inDB->fetch_assoc($result)){
			if (!$is_first) {
				$output_str.=', '; 
			}
			$is_first=0;	
			$output_str.='"cat_'.$item['cat_id'].'" : {"parent_id" : '.$item['parent_id'].', "is_group" : '.$item['is_group'].', "title" : "'.$item['title'].'","children" : ';
			$output_str.= $item['is_group'] ? $this->getCategories($item['cat_id']) : '{}';	
			$output_str.='}';
		}
		$output_str.='}';
        return $output_str;
    }
/* ==================================================================================================== */	
	public function categoryTitle($cat_id=0){ //  
	    if (!$cat_id) return '';
        $sql = "SELECT * FROM cms_cal_cats WHERE cat_id=".$cat_id;
        $result = $this->inDB->query($sql) ;
		if (!mysql_num_rows($result)) return '';
		$item = $this->inDB->fetch_assoc($result);
		return $item['parent_id'] ? $this->categoryTitle($item['parent_id']).'.'.$item['title'] : $item['title'];         
    }
/* ==================================================================================================== */	
	public function isInCategory($where_cat_id=0, $what_cat_id=0){ //  
	    if ($where_cat_id==$what_cat_id) return true; // (, )     - 
	    if (!$where_cat_id) return true; //    - 
		if (!$what_cat_id) return false; //    -  
        $sql = "SELECT * FROM cms_cal_cats WHERE cat_id=".$what_cat_id." and parent_id=".$where_cat_id;
        $result = $this->inDB->query($sql);
		if (mysql_num_rows($result)) return true; //    
		$sql = "SELECT parent_id FROM cms_cal_cats WHERE cat_id=".$what_cat_id;
        $result = $this->inDB->query($sql);
		$item = $this->inDB->fetch_assoc($result);
		return $item['parent_id'] ? $this->isInCategory($where_cat_id,$item['parent_id']) : false;		
    }
/* ==================================================================================================== */	
	public function subcategoryList($parent_cat_id=0){ //   cat_id   
		if (!$parent_cat_id) return false;
		$output='["'.$parent_cat_id.'"';
		$sql = "SELECT cat_id, is_group FROM cms_cal_cats WHERE parent_id=".$parent_cat_id;
        $result = $this->inDB->query($sql);
		while($item = $this->inDB->fetch_assoc($result)){
			$output.=',"'.$item['cat_id'].'"';
			if ($item['is_group']) $output=$this->categoryListInternal($output, $item['cat_id']);		
		}
		$output.=']';
		return $output;		
    }
/* ==================================================================================================== */	
	private function subcategoryListInternal($output, $parent_cat_id){
		$sql = "SELECT cat_id, is_group FROM cms_cal_cats WHERE parent_id=".$parent_cat_id;
        $result = $this->inDB->query($sql);		
		while($item = $this->inDB->fetch_assoc($result)){
		    $output.=',"'.$item['cat_id'].'"';
			if ($item['is_group']) $output=$this->categoryListInternal($output, $item['cat_id']);		
		}
		return $output;		
    }					
/* ==================================================================================================== */
    public function addSubcategory($parent_id=0, $title){
		$sql = "SELECT cat_id FROM cms_cal_cats WHERE parent_id=".$parent_id." AND title='".$title."'";
        $result = $this->inDB->query($sql) ;
		if (mysql_num_rows($result)) return false; //title  
		$sql = "INSERT INTO cms_cal_cats (parent_id, is_group, title) 
           VALUES ({$parent_id}, 0, '{$title}')";
        $this->inDB->query($sql);		
		$item_id = $this->inDB->get_last_id('cms_cal_cats');
		$sql = "UPDATE cms_cal_cats SET is_group=1
                WHERE cat_id = {$parent_id}";
        $this->inDB->query($sql);
        return $item_id ? $item_id : false;
    }		
/* ==================================================================================================== */
    public function renameSubcategory($cat_id, $new_title) {        
        $sql = "UPDATE cms_cal_cats
                SET title='{$new_title}'
                WHERE cat_id = {$cat_id}";
        $this->inDB->query($sql);
        return true;
    }
/* ==================================================================================================== */
    public function removeSubcategory($cat_id=0){
		$sql = "SELECT cat_id FROM cms_cal_cats WHERE parent_id=".$cat_id;
        $result = $this->inDB->query($sql) ;
		if (mysql_num_rows($result)) return false; //   
		$sql = "select parent_id from cms_cal_cats where cat_id=".$cat_id;
        $result = $this->inDB->query($sql);
		$item = $this->inDB->fetch_assoc($result);
		$parent_id=$item['parent_id'];
		$sql = "SELECT cat_id FROM cms_cal_cats WHERE parent_id=".$parent_id;
        $result = $this->inDB->query($sql) ;
		if (mysql_num_rows($result)==1) {
		   //    
		   $sql = "UPDATE cms_cal_cats SET is_group=0
                   WHERE cat_id =".$parent_id;
           $this->inDB->query($sql);			
		}
		$sql = "DELETE FROM cms_cal_cats WHERE cat_id={$cat_id}";
        $this->inDB->query($sql);		
        return true;
    }
	
	
}